import itertools


class Variable:
    # Increment the var number automatically every time a variable is created
    incremental_number = itertools.count().__next__

    def __init__(self, procedure, _name, _type, _dimension, _module):
        import AutoRPE.UtilsRPE.BasicFunctions as BasicFunctions
        self.id = None
        self.incremental_number = Variable.incremental_number()
        self.module = _module
        self.procedure = procedure
        self.name = _name
        self.type = _type
        self.original_type = _type
        self.dimension = _dimension
        self.is_dummy_argument = False
        self.intent = None
        self.is_global = True if self.procedure.name == 'main' else False
        self.is_optional = None
        self.is_retval = False
        self.is_pointer = False
        self.position = None
        self.mandatory_position = None
        self.is_allocatable = False
        self.allocate_info = AllocateInfo(None, False)
        self.appears_in_namelist = False
        self.is_used_in_external = None
        self.precision = None
        self.is_parameter = None
        self.is_member_of = None
        self.same_as = []
        self.hash_id = BasicFunctions.hash_from_list([self.name, self.procedure.name, self.module.name])
        # to be used in the analysis
        self.is_used = False
        self.cluster_id = -1
        self.is_banned = False

    def is_equal_to(self, other):
        return self.name == other.name and \
               self.type == other.type and \
               self.is_member_of == other.is_member_of and \
               self.dimension == other.dimension and \
               self.is_pointer == other.is_pointer


class AllocateInfo:
    def __init__(self, _line_info, _is_deallocated):
        self.line_info = _line_info
        self.is_deallocated = _is_deallocated

